/****************************************************************************

 Copyright 2003 Matthew Riek
 See legal notice in copyright.txt

 Description : micro xml parser

 ****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <crtdbg.h>

#include "mxmldom.h"
#include "mxmlstream.h"

#ifdef _DEBUG
#define SET_CRT_DEBUG_FIELD(a) \
_CrtSetDbgFlag((a) | _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG))
#define CLEAR_CRT_DEBUG_FIELD(a) \
_CrtSetDbgFlag(~(a) & _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG))
#else
#define SET_CRT_DEBUG_FIELD(a) ((void) 0)
#define CLEAR_CRT_DEBUG_FIELD(a) ((void) 0)
#endif

int main()
{
  {
    MXMLStreamFile file("test.xml", "rb");
    if(file.IsOpen())
    {
      MXMLDocument document;
      if(document.Load(file, 16384))
      {
        MXMLStreamFile saveFile("testout.xml", "wb");
        if(saveFile.IsOpen())
        {
          document.Save(saveFile);
        }
      }
      else
      {
        printf("%s\n", document.GetBuffer());
      }
    }
  }

  SET_CRT_DEBUG_FIELD( _CRTDBG_LEAK_CHECK_DF ); 

  exit(0);
}